<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'insert|success';
$subbox = array(
        "module" => 'consultation',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'consultation';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'consultation', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);
$smarty->assign('ur_here', $dou->ur_here('consultation'));
$smarty->assign('head', $_LANG['consultation']);

/**
 * +----------------------------------------------------------
 * 业务咨询
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // 赋值给模板-meta和title信息
    $smarty->assign('page_title', $dou->page_title('consultation'));
    
    // 赋值给模板-数据
    $smarty->assign('insert_url', $_URL['insert']);
    
    $smarty->display('consultation.dwt');
}

/**
 * +----------------------------------------------------------
 * 咨询添加
 * +----------------------------------------------------------
 */
if ($rec == 'insert') {
    $ip = $dou->get_ip();
    $add_time = time();
    $captcha = $check->is_captcha($_POST['captcha']) ? strtoupper($_POST['captcha']) : '';
        
    // 如果限制必须输入中文则修改错误提示
    $include_chinese = $_CFG['guestbook_check_chinese'] ? $_LANG['consultation_include_chinese'] : '';
    
    // 验证主题
    if ($check->is_illegal_char($_POST['contact'])) {
        $wrong['contact'] = $_LANG['consultation_contact'] . $_LANG['illegal_char'];
    } elseif (!$check->length($_POST['contact'], 50)) {
        $wrong['contact'] = $_LANG['consultation_contact_wrong'];
    }
    
    // 验证联系人
    if ($check->is_illegal_char($_POST['telphone'])) {
        $wrong['telphone'] = $_LANG['consultation_telphone'] . $_LANG['illegal_char'];
    } elseif (!$check->is_telphone($_POST['telphone'])) {
        $wrong['telphone'] = $_LANG['consultation_telphone'] . $_LANG['is_wrong'];
    }
 
    if ($_POST['all_field']) {
        // 验证邮箱
        if (empty($_POST['email'])) {
            $wrong['email'] = $_LANG['consultation_email'] . $_LANG['is_empty'];
        } elseif (!$check->is_email($_POST['email'])) {
            $wrong['email'] = $_LANG['consultation_email'] . $_LANG['is_wrong'];
        }
     
        if ($_CFG['language'] != 'zh_cn') {
            // 验证country
            if ($check->is_illegal_char($_POST['country'])) {
                $wrong['country'] = $_LANG['consultation_country'] . ' / ' . $_LANG['consultation_province'] . $_LANG['illegal_char'];
            } elseif (empty($_POST['country'])) {
                $wrong['country'] = $_LANG['consultation_country'] . ' / ' . $_LANG['consultation_province'] . $_LANG['is_empty'];
            }
        }
     
        // 验证公司
        if ($check->is_illegal_char($_POST['company']))
            $wrong['company'] = $_LANG['consultation_company'] . $_LANG['illegal_char'];
    }
    
    // 验证咨询内容
    if ($check->is_illegal_char($_POST['brief'])) {
        $wrong['brief'] = $_LANG['consultation_brief'] . $_LANG['illegal_char'];
    } elseif (!$check->length($_POST['brief'], 300)) {
        $wrong['brief'] = $_LANG['consultation_brief_wrong'];
    }
    
    // 判断验证码
    if (isset($_POST['captcha']) && $_CFG['captcha'] && md5($captcha . DOU_SHELL) != $_SESSION['captcha'])
        $wrong['captcha'] = $_LANG['captcha_wrong'];
    
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }
    
    // 检查IP是否频繁咨询
    if (is_water($ip))
        $dou->dou_msg($_LANG['consultation_is_water'], $_URL['consultation'], 10);
    
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['consultation']);
    }

    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);
    
    $sql = "INSERT INTO " . $dou->table('consultation') . " (id, contact, telphone, email, country, province, company, brief, ip, add_time)" . " VALUES (NULL, '$_POST[contact]', '$_POST[telphone]', '$_POST[email]', '$_POST[country]', '$_POST[province]', '$_POST[company]', '$_POST[brief]', '$ip', '$add_time')";
    $dou->query($sql);
    
    $dou->dou_msg($_LANG['consultation_insert_success'], $_URL['consultation']);
}

/**
 * +----------------------------------------------------------
 * 防灌水
 * +----------------------------------------------------------
 */
function is_water($ip) {
    $unread = $GLOBALS['dou']->get_one("SELECT COUNT(*) FROM " . $GLOBALS['dou']->table('consultation') . " WHERE ip = '$ip' AND status = 0");
    
    // 如果管理员未回复的咨询数量大于1
    if ($unread >= 1)
        return true;
}

?>